//============================================================================
// Name        : nic_restart.cpp
// Author      : -=SilliCone=-
// Version     :
// Copyright   : Open Source
// Description : Restarts NIC in case of unwanted IP adress
//				let it run periodical by cron
//============================================================================

#include <iostream>
#include <fstream>
#include <stdio.h>
#include <cstdlib>
#include <string.h>
#include <stdlib.h>

using namespace std;

char version[10] = "0.1";	//Version
char nic[6];
char ip1[5], ip2[5], ip3[5];
char line[100], Vergleichsmuster[100], muster[100], *nic_, *ip1_, *ip2_, *ip3_, cmdline[100], restartcmd[100];

int main(int argc, char *argv[])
{
	cout << "NIC restart V" << version << "\n";
	cout << "2012 by -=SilliCone=-\n" << endl;

// #### config ffnen
	ifstream config("nic_restart_config");
	if (!config)
	{
		cout << "\nnic_restart_config not found, generating new file with defaults. Please check.\n\n";

		ofstream config_new("nic_restart_config");
		if (!config_new)
		{
			cout << "Can't write nic_restart_config, possibly no write permissions. Please check.\n\n";
			return 10;		// #### Programmende, user soll erstmal chekcen ob er schreibrechte hat
			}
		config_new << "Configuration file for NIC restart V" << version << "\n";
		config_new << "if you do change this file, mind the exact syntax !!!\n";
		config_new << "NIC : eth1\n";
		config_new << "unwanted IP Class 1 : 192\n";
		config_new << "unwanted IP Class 2 : 169\n";
		config_new << "unwanted IP Class 3 : 169\n";
		config_new << "EOC";
		return 15;	// #### Programmende, config wurde erstellt, alles weiter im naechsten programmdurchlauf
		}

// ####	erstmal aus der configdatei den namen des interfaces rauslesen
	strcpy (Vergleichsmuster, "NIC : ");
	while (config)	// #### solange nicht dateiende erreicht wurde
	{
		config.getline(line, sizeof line);	// #### ne Zeile aus der config einlesen
		strncpy (muster, line,6);			// #### die ersten 6 Zeichen aus der zeile als muster laden

		if (!strncmp (muster, Vergleichsmuster,6))
		{
//			cout << line << "\n"; // debug
			nic_ = (strchr (line, ':') +2); 	// #### die Stelle suchen wo im String der NIC vorkommt
												// #### im Prinzip wird der String ab da gelesen wo das gesuchte Zeichen (+2) das erstemal vorkommt
			strcpy (nic, nic_);					// #### das ganze kopiert
//			cout << nic << "\n";				// #### debug
			}
		}
	config.close();

// #### jetzt die erste IP auslesen
	ifstream configIP1("nic_restart_config");
	strcpy (Vergleichsmuster, "unwanted IP Class 1 : ");

	while (configIP1)	// #### solange nicht dateiende erreicht wurde
	{
		configIP1.getline(line, sizeof line);	// #### ne Zeile aus der config einlesen
		strncpy (muster, line,22);			// #### die ersten 22 Zeichen aus der zeile als muster laden

		if (!strncmp (muster, Vergleichsmuster,22))
		{
			ip1_ = (strchr (line, ':') +2); 	// #### die Stelle suchen wo im String die erste IP vorkommt
											// #### im Prinzip wird der String ab da gelesen wo das gesuchte Zeichen (+2) das erstemal vorkommt
			strcpy (ip1, ip1_);					// #### das ganze kopiert
//			cout << ip1 << "\n";				// #### debug
			}
		}
	configIP1.close();

// #### jetzt die zweite IP auslesen
		ifstream configIP2("nic_restart_config");
		strcpy (Vergleichsmuster, "unwanted IP Class 2 : ");

		while (configIP2)	// #### solange nicht dateiende erreicht wurde
		{
			configIP2.getline(line, sizeof line);	// #### ne Zeile aus der config einlesen
			strncpy (muster, line,22);			// #### die ersten 22 Zeichen aus der zeile als muster laden

			if (!strncmp (muster, Vergleichsmuster,22))
			{
				ip2_ = (strchr (line, ':') +2); 	// #### die Stelle suchen wo im String die erste IP vorkommt
													// #### im Prinzip wird der String ab da gelesen wo das gesuchte Zeichen (+2) das erstemal vorkommt
				strcpy (ip2, ip2_);					// #### das ganze kopiert
//				cout << ip2 << "\n";				// #### debug
				}
			}
		configIP2.close();

// #### jetzt die dritte IP auslesen
		ifstream configIP3("nic_restart_config");
		strcpy (Vergleichsmuster, "unwanted IP Class 3 : ");

		while (configIP3)	// #### solange nicht dateiende erreicht wurde
		{
			configIP3.getline(line, sizeof line);	// #### ne Zeile aus der config einlesen
			strncpy (muster, line,22);			// #### die ersten 22 Zeichen aus der zeile als muster laden

			if (!strncmp (muster, Vergleichsmuster,22))
			{
				ip3_ = (strchr (line, ':') +2); 	// #### die Stelle suchen wo im String die erste IP vorkommt
													// #### im Prinzip wird der String ab da gelesen wo das gesuchte Zeichen (+2) das erstemal vorkommt
				strcpy (ip3, ip3_);					// #### das ganze kopiert
//				cout << ip3 << "\n";				// #### debug
				}
			}
		configIP3.close();

// #### EINLESEN DER KONFIGURATION ABGESCHLOSSEN

// #### wir basteln eine Kommandozeile um die Konfiguration des genannten interfaces herauszufinden
	strcpy (cmdline, "ifconfig ");
	strcat (cmdline, nic);
	strcat (cmdline, " > ifconfig_");
	strcat (cmdline, nic);

// #### Kommandozeile ausfhren
//	cout << "command : " << cmdline << "\n";	// #### debug
	system (cmdline);

// #### Dateinamen der erstellten Datei bauen
	strcpy (cmdline, "ifconfig_");
	strcat (cmdline, nic);

// #### restartbefehl bauen
	strcpy (restartcmd, "/etc/rc.d/rc.inet1 ");
	strcat (restartcmd, nic);
	strcat (restartcmd, "_stop;/etc/rc.d/rc.inet1 ");
	strcat (restartcmd, nic);
	strcat (restartcmd, "_start");
//	cout << "\nrestartcmd : " << restartcmd << endl;	// debug

// #### erstellte Datei auslesen, nach der ersten IP-Adresse suchen
	ifstream genfile1(cmdline);
	if (!genfile1)
	{
		cout << "Can't open " << cmdline << "\n";
		cout << "Do i run as root?" << endl;
		return 20;
		}

	strcpy (Vergleichsmuster, "          inet addr:");	// #### 20 zeichen

	while (genfile1)	// #### solange nicht dateiende erreicht wurde
	{
				genfile1.getline(line, sizeof line);	// #### ne Zeile einlesen
				strncpy (muster, line,20);			// #### die ersten 20 Zeichen aus der zeile als muster laden

				if (!strncmp (muster, Vergleichsmuster,20))
				{
					ip1_ = (strchr (line, ':') +1); 	// #### die Stelle suchen wo im String die erste IP vorkommt
														// #### im Prinzip wird der String ab da gelesen wo das gesuchte Zeichen (+2) das erstemal vorkommt
					if (!strncmp (ip1, ip1_,3)) 		// #### sind die ersten 3 byte gleich mit der ersten der 3 gersuchten ungewollten ip-adressen?
					{
//						cout << ip1_ << "\n";			// #### debug
						system (restartcmd);			// #### interface wird neu gestartet
						cout << "\n" << nic << " has been restartet" << endl;	// #### sag dem user was passiert ist
						return 99;						// #### Programmende, ein Interface wurd eneu gestrtet
						}
					}
				}
			genfile1.close();

// #### erstellte Datei auslesen, nach der zweiten IP-Adresse suchen
	ifstream genfile2(cmdline);
	if (!genfile2)
	{
		cout << "Can't open " << cmdline << "\n";
		cout << "Do i run as root?" << endl;
		return 20;
		}

	strcpy (Vergleichsmuster, "          inet addr:");	// #### 20 zeichen

	while (genfile2)	// #### solange nicht dateiende erreicht wurde
	{
		genfile2.getline(line, sizeof line);	// #### ne Zeile einlesen
		strncpy (muster, line,20);			// #### die ersten 20 Zeichen aus der zeile als muster laden

		if (!strncmp (muster, Vergleichsmuster,20))
		{
			ip2_ = (strchr (line, ':') +1); 	// #### die Stelle suchen wo im String die IP vorkommt
												// #### im Prinzip wird der String ab da gelesen wo das gesuchte Zeichen (+2) das erstemal vorkommt
			if (!strncmp (ip2, ip2_,3)) 		// #### sind die ersten 3 byte gleich mit der ersten 3 der gesuchten ungewollten ip-adressen?
			{
//				cout << ip2_ << "\n";			// #### debug
				system (restartcmd);			// #### interface wird neu gestartet
				cout << "\n" << nic << " has been restartet" << endl;	// #### sag dem user was passiert ist
				return 99;						// #### Programmende, ein Interface wurd eneu gestrtet
				}
			}
		}
	genfile2.close();

// #### erstellte Datei auslesen, nach der dritten IP-Adresse suchen
	ifstream genfile3(cmdline);
	if (!genfile3)
	{
		cout << "Can't open " << cmdline << "\n";
		cout << "Do i run as root?" << endl;
		return 20;
		}

	strcpy (Vergleichsmuster, "          inet addr:");	// #### 20 zeichen

	while (genfile3)	// #### solange nicht dateiende erreicht wurde
	{
		genfile3.getline(line, sizeof line);	// #### ne Zeile einlesen
		strncpy (muster, line,20);			// #### die ersten 20 Zeichen aus der zeile als muster laden

		if (!strncmp (muster, Vergleichsmuster,20))
		{
			ip3_ = (strchr (line, ':') +1); 	// #### die Stelle suchen wo im String die IP vorkommt
													// #### im Prinzip wird der String ab da gelesen wo das gesuchte Zeichen (+2) das erstemal vorkommt
			if (!strncmp (ip3, ip3_,3)) 		// #### sind die ersten 3 byte gleich mit der ersten 3 der gesuchten ungewollten ip-adressen?
			{
//				cout << ip3_ << "\n";			// #### debug
				system (restartcmd);			// #### interface wird neu gestartet
				cout << "\n" << nic << " has been restartet" << endl;	// #### sag dem user was passiert ist
				return 99;						// #### Programmende, ein Interface wurd eneu gestrtet
				}
			}
		}
	genfile3.close();

// #### wenn das pro bis hierher kommt hat es nichts gefunden
	cout << "\n" << nic << " has NOT been restartet, none of the configured IP found" << endl;

	return 0;
	}
